* Copyright, 2004, Tamar E. Granor
* From: What's New in Nine: Visual FoxPro's Latest Hits
* www.hentzenwerke.com
* Add records to _FoxCode for the MessageBox()
* parameter Property Editor

LOCAL cFormFile, cScript, cTip
LOCAL cOldExcl

* First, check whether it's already there.
cOldExcl = SET("Exclusive")
SET EXCLUSIVE OFF 

SELECT Abbrev ;
	FROM (_FoxCode) ;
	WHERE Type = "S" ;
	  AND UPPER(Abbrev) = "MESSAGESCRIPT" ;
	  AND NOT DELETED() ;
	INTO CURSOR ScriptRec

SET EXCLUSIVE &cOldExcl

IF _Tally > 0
	MESSAGEBOX("Script record already stored in IntelliSense table.")
	RETURN
ENDIF

USE IN ScriptRec

* Locate the form
cFormFile = LOCFILE("MessageBoxParams.SCX","SCX","Form location:")

* Build the script
TEXT TO cScript TEXTMERGE NOSHOW 
LPARAMETERS tcProp

LOCAL ARRAY laObjs[1]
LOCAL lnRetVal, lnCnt, loCtl,lnDefValue, lnSuccess
IF ASELOBJ( laObjs)=0
	IF ASELOBJ( laObjs,1)=0
		RETURN
	ENDIF
ENDIF

lnDefValue=IIF(ALEN( laObjs,1)=1,laObjs[1].&tcProp,0)
lnRetVal =0
DO FORM "<<cFormFile>>" WITH lnDefValue to lnRetVal

FOR lnCnt = 1 TO ALEN( laObjs,1)
	loCtl = laObjs[lnCnt]
	IF PEMSTATUS( loCtl, tcProp, 5 )
		loCtl.&tcProp = lnRetVal
	ENDIF
ENDFOR

ENDTEXT


TRY
	* Add the script record
	* Open the table first, so we have usable alias
	USE (_FoxCode) AGAIN SHARED ALIAS __FoxCode
	INSERT INTO (_FoxCode) ;
		(Type, Abbrev, Cmd, Data, TimeStamp, UniqueID) ;
		VALUES ("S", "MessageScript", "{}", ;
		        cScript, DATETIME(), SYS(2015))
		
CATCH
	MESSAGEBOX("Unable to add script record")
	RETURN 
ENDTRY

* Build the MessageData for nMessageParam
TEXT TO cTip NOSHOW 
<VFPData><memberdata name="nmessageparam" type="property" display="nMessageParam" script="DO (_CODESENSE) WITH 'RunPropertyEditor','','nmessageparam'
"/></VFPData>
ENDTEXT

TRY
	* Look for existing record
	SELECT __FoxCode
	LOCATE FOR Type="E" AND UPPER(Abbrev) = "NMESSAGEPARAM" AND NOT DELETED()
	IF FOUND()
		* Update it. This is a quick & dirty
		* version that overwrites any existing 
		* MemberData.
		REPLACE Cmd WITH "{MessageScript}", ;
				Tip WITH cTip
	ELSE
		INSERT INTO (_FoxCode) ;
			(Type, Abbrev, Cmd, Tip, TimeStamp, UniqueID) ;
			VALUES ("E", "nMessageParam", ;
			        "{MessageScript}", cTip, ;
			        DATETIME(), SYS(2015))
	ENDIF

CATCH
	MESSAGEBOX("Unable to add record for nMessageParam")

FINALLY
	IF USED("__FoxCode")
		USE IN __FoxCode
	ENDIF
ENDTRY

RETURN
	